package com.benyun.core.controller;

import com.benyun.core.constant.RedisContant;
import com.benyun.core.entity.Brand;
import com.benyun.core.entity.bo.WdCount;
import com.benyun.core.entity.vo.ChannelAnalyseAceeptVo;
import com.benyun.core.service.ChannelAnalyseService;
import com.github.pagehelper.PageInfo;
import com.ruoyi.common.core.domain.R;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.HashMap;
import java.util.concurrent.TimeUnit;

@RestController
@RequestMapping("/channelAnalyse")
public class ChannelAnalyseController {

    @Autowired
    ChannelAnalyseService channelAnalyseService;
    @Autowired
    RedisTemplate redisTemplate;

    @RequestMapping("/cityTier")
    public R cityTier(ChannelAnalyseAceeptVo channelAnalyseAceeptVo){
        String md5 = channelAnalyseAceeptVo.getHash();

        //2.查看redis中是否存在有缓存
        HashMap wdCount = (HashMap) redisTemplate.boundHashOps(RedisContant.CHANNEL_ANALYSE_CITYTIER).get(md5);
        if (wdCount != null) {
            return R.ok(wdCount);
        }

        HashMap hashMap = channelAnalyseService.cityTier(channelAnalyseAceeptVo);

        //4.保存到redis中
        redisTemplate.boundHashOps(RedisContant.CHANNEL_ANALYSE_CITYTIER).put(md5,hashMap);
        redisTemplate.expire(RedisContant.CHANNEL_ANALYSE_CITYTIER,RedisContant.CHANNEL_ANALYSE_CITYTIER_TIME, TimeUnit.MINUTES); //30分钟
        return R.ok(hashMap);
    }

    @RequestMapping("/brandList")
    public R brandList(ChannelAnalyseAceeptVo channelAnalyseAceeptVo){
        PageInfo<Brand> brandPageInfo = channelAnalyseService.brandList(channelAnalyseAceeptVo);
        return R.ok(brandPageInfo);
    }
}
