package com.benyun.core.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.benyun.core.dao.BrandMapper;
import com.benyun.core.dao.WdInfoDao;
import com.benyun.core.entity.Brand;
import com.benyun.core.entity.CityTierBody;
import com.benyun.core.entity.TopologicalStoreWd;
import com.benyun.core.entity.WdInfo;
import com.benyun.core.entity.vo.ChannelAnalyseAceeptVo;
import com.benyun.core.service.ChannelAnalyseService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;

@Service
public class ChannelAnalyseServiceImpl implements ChannelAnalyseService {

    @Autowired
    WdInfoDao wdInfoDao;

    @Autowired
    @Qualifier("cityTierMap")
    HashMap<String,String> cityTierMap;

    @Autowired
    BrandMapper brandMapper;

    @Override
    public HashMap cityTier(ChannelAnalyseAceeptVo channelAnalyseAceeptVo) {
        HashMap<String,Long> result = new HashMap<>();
        result.put("一线",0L);
        result.put("新一线",0L);
        result.put("二线",0L);
        result.put("三线",0L);
        result.put("四线",0L);
        result.put("五线",0L);
        result.put("其他",0L);

        //1.获取所有符合条件的网点信息
        QueryWrapper<WdInfo> queryWrapper = new QueryWrapper<>();
        queryWrapper.in("wd_type_code", channelAnalyseAceeptVo.getChannel());
        if(channelAnalyseAceeptVo.getSearchText() != null && !channelAnalyseAceeptVo.getSearchText().equals("")){
            queryWrapper.and(wdInfoQueryWrapper -> {
                wdInfoQueryWrapper.like("wd_name",channelAnalyseAceeptVo.getSearchText());
            });
        }

        List<WdInfo> wdInfos = wdInfoDao.selectList(queryWrapper);
        System.out.println(wdInfos.size());
        for (WdInfo wdInfo : wdInfos) {
            String addrCode = wdInfo.getAddrCode();
            if(cityTierMap.containsKey(addrCode)){
                result.put(cityTierMap.get(addrCode),result.get(cityTierMap.get(addrCode))+1);
            }else if(cityTierMap.containsKey(addrCode.substring(0,4))){
                result.put(cityTierMap.get(addrCode.substring(0,4)),result.get(cityTierMap.get(addrCode.substring(0,4)))+1);
            }else if(cityTierMap.containsKey(addrCode.substring(0,2))){
                result.put(cityTierMap.get(addrCode.substring(0,2)),result.get(cityTierMap.get(addrCode.substring(0,2)))+1);
            }
            else
                result.put("其他",result.get("其他")+1);
        }


        return result;
    }

    @Override
    public PageInfo<Brand> brandList(ChannelAnalyseAceeptVo channelAnalyseAceeptVo) {
        PageHelper.startPage(channelAnalyseAceeptVo.getPageNum(),channelAnalyseAceeptVo.getPageSize());
        List<Brand> brands = brandMapper.searchList(channelAnalyseAceeptVo.getSearchText());
        PageInfo<Brand> pageInfo = new PageInfo<>(brands);
        return pageInfo;
    }
}
