package com.benyun.core.service.impl;

import com.benyun.core.dao.TypeByDao;
import com.benyun.core.dao.WdInfoMapper;
import com.benyun.core.entity.TypeBy;
import com.benyun.core.entity.WdInfo;
import com.benyun.core.entity.vo.AddrCategoryBody;
import com.benyun.core.entity.vo.TypeByBody;
import com.benyun.core.entity.vo.WdInfoVo;
import com.benyun.core.service.WdRecycleService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.stream.Collectors;

@Service
public class WdRecycleServiceImpl implements WdRecycleService {



    @Autowired
    WdInfoMapper wdInfoMapper;


    @Autowired
    @Qualifier("addrCodeMap")
    private HashMap<String,String> addrCodeMap;



    @Override
    public HashMap<String, Object>  list(WdInfoVo wdInfoVo) {

        PageHelper.startPage(wdInfoVo.getPageNum(), wdInfoVo.getPageSize());
        PageHelper.orderBy(wdInfoVo.getOrderBy()+" desc");
        List<WdInfo> wdInfos = wdInfoMapper.list(wdInfoVo);
        PageInfo<WdInfo> pageInfo = new PageInfo<>(wdInfos);

        List<WdInfoVo> collect = wdInfos.stream().map(wdInfo -> {
            if(wdInfo.getTypeNameBy() != null){
                String[] split = wdInfo.getTypeNameBy().split(":");
                if(split.length == 3)
                    wdInfo.setTypeNameBy(split[2]);
                else if(split.length == 2)
                    wdInfo.setTypeNameBy(split[1]);
                else
                    wdInfo.setAddrInfo(wdInfo.getTypeNameBy().replace(":",""));
            }

            WdInfoVo wdInfoVo1 = new WdInfoVo(wdInfo);
            wdInfoVo1.setAddrCodeInfo(addrCodeMap.get(wdInfoVo1.getAddrCode()));
            return wdInfoVo1;
        }).collect(Collectors.toList());

        HashMap<String, Object> result = new HashMap<>();
        pageInfo.setList(null);
        result.put("page",pageInfo);
        result.put("data",collect);
        return result;
    }


}
