package com.benyun.core.service;

import com.benyun.core.entity.bo.AttentionPoolBo;
import com.benyun.core.entity.vo.TurnBusinessOpportunitiesVo;
import com.benyun.core.entity.vo.WorkTableSearchVo;
import com.github.pagehelper.PageInfo;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.util.List;

@SpringBootTest
public class AttentionPoolServiceImplTest {
    @Autowired
    AttentionPoolService attentionPoolService;

    @Test
    public void searchListTest(){
        WorkTableSearchVo vo = new WorkTableSearchVo();
        vo.setText("1");
        PageInfo<List<AttentionPoolBo>> info = attentionPoolService.searchList(vo, "1");
        System.out.println(info);
    }

    @Test
    public void turnBusinessOpportunitiesTest(){
        TurnBusinessOpportunitiesVo vo = new TurnBusinessOpportunitiesVo();
        vo.setAttentionId("2");
        vo.setContact("xxx");
        vo.setTelephone("130xxx");
        System.out.println(attentionPoolService.turnBusinessOpportunities(vo,"1"));
    }

    @Test
    public void cancelAttentionTest(){
        System.out.println(attentionPoolService.cancelAttention("3000","2"));
    }

    @Test
    public void attentionBrandTest(){
        String userId = "1";
//        String brandId = "5eb6d4ccee1d498997c26a140a4bef08";
        String brandId = "fhlksjdflkjsldkjf";
        System.out.println(attentionPoolService.attentionBrand(brandId, userId));
    }

    @Test
    public void cancelBrandTest(){
        String userId = "1";
        String brandId = "5eb6d4ccee1d498997c26a140a4bef08";
        System.out.println(attentionPoolService.cancelBrand(brandId,userId));
    }

    @Test
    public void attentionWdInfoTest(){
        String userId = "1";
//        String wdId = "0001ec104d7049eab1f992732e089518";
        String wdId = "fjklsdjflksjdfkljsdf";
        System.out.println(attentionPoolService.attentionWdInfo(wdId,userId));
    }

    @Test
    public void cancelWdInfo(){
        String userId = "1";
        String wdId = "0001ec104d7049eab1f992732e089518";
        System.out.println(attentionPoolService.cancelWdInfo(wdId,userId));
    }
}
